> For the complete documentation index, see [llms.txt](https://docs.servoy.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.servoy.com/reference/servoy-developer/debugger.md).

# Debugger

- [Debug Explorer](https://docs.servoy.com/reference/servoy-developer/debugger/debug-explorer.md): The Debug Explorer or Perspective comes in handy when trying trying to step through code to resolve bugs and figuring out the flow of business logic.
- [Breakpoints](https://docs.servoy.com/reference/servoy-developer/debugger/breakpoints.md)
- [Breakpoint Properties](https://docs.servoy.com/reference/servoy-developer/debugger/breakpoints/breakpoint-properties.md)
- [Variables](https://docs.servoy.com/reference/servoy-developer/debugger/variables.md): Within the debug perspective you can find the Variables Panel.  It allows use to view variables and objects at runtime when a break point is hit.
- [Expressions](https://docs.servoy.com/reference/servoy-developer/debugger/expressions.md)
- [Interactive Console](https://docs.servoy.com/reference/servoy-developer/debugger/interactive-console.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.servoy.com/reference/servoy-developer/debugger.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
